using System;

namespace BaseTypes
{
  /// <summary>
  /// - System namespace contain most functionality for base types
  /// - Everything has to be inside a class in C#
  /// - Also base types are boxed into object
  /// - enumerators usage
  /// - base types (int/Int32)
  /// - nullable types
  /// </summary>
  class Program
  {
    static void Main(string[] args) //command line params are stored in "args" array
    {
      int intA = 5; //key word pointing to Int32 (also string points to String)
      Int32 intB = 23;
      intA = int.MaxValue;//integer range
      string intAString = intA.ToString();//integer is also bexed into object

      System.Nullable<int> intNull = 5; //nullable types
      intNull = null;
      int? intNullB = null; //second usage

      Girl g = Girl.Angel; //enumerator usage
      int gInt = (int)g; //enum value boxed into integer
      foreach (string girl in Enum.GetNames(typeof(Girl))) //all aplicable type names
      {
        Console.WriteLine(girl);
      }

      MyGirl natasha; //structure called without initialization
      natasha.Name = "Hilda";

      GirlFrend cat;  //class have to be initialized with constructor first, otherwise is null!
      cat = new GirlFrend();

      int age = 20;
      isForMe(age);
      isForMeRef(ref age);//you have to use "ref" key word

      Console.ReadKey();
    }

    /// <summary>
    /// you work with value copy, original age isnt changed.
    /// Only for value types.
    /// </summary>
    public static bool isForMe(int age)
    {
      age = 80;//value is changed only inside this method
      if (age < 18 && age > 30) return false;
      else return true;
    }

    /// <summary>
    /// age have to be used with "ref" key word for reference call
    /// Original age is changed.
    /// Classes are allways call as referenced! Also when you doesnt use "ref" key word.
    /// </summary>
    public static bool isForMeRef(ref int age)
    {
      age = 80;
      if (age < 18 && age > 30) return false;
      else return true;
    }

  }
}
