using System;
using System.Text;

namespace TypeConversions
{
  /// <summary>
  /// 04 - TypeConversions
  /// - boxing can be up to 20 times slower than conversion, but cant be used only on base types
  /// - System.ConvertTo(..) methods
  /// - String and string builder
  /// - numeric conversions
  /// - division errors
  /// Comparation:
  ///  - Conversion: throws exception if conversion fails
  ///  - boxing: throws type cast exception
  ///  - operator as: only for reference types, if boxing fails, then returns null
  /// </summary>
  class Program
  {
    static void Main(string[] args)
    {
      int loversCount = 5;
      int loversCount2 = 10/4; //result 2
      //int loversCount2 = (double)10 / 4; //uncompatible types in operation

      double loversCount3 = (double)10 / 0; //infinity

      int b = 0;
      //int loversCount4 = 10 / b; //DvideByZeroException

      object obj = (object)b; //boxing
      loversCount3 = Convert.ToDouble(obj);
      loversCount3 = (int)obj;

      string killerName = "Volodja";// string is allways readonly, unicode and null terminated
      string firstLetter = killerName.Substring(0, 1); //first letter
      if (killerName == "Volodja") /*run*/;
      string killerString = String.Format("First letter of {0} name"
        + Environment.NewLine + "is {1}", killerName, firstLetter);
      //new line in windows "\r\n" general solution for platform independet code
      //use Environment.NewLine property
      Console.Write(killerString);

      getLetters();
      Console.ReadKey();
      //handfull type libraries
      // System.Data - ADO .NET data types
      // System.XML
      // System.Text - StringBuilder
      // System.Collections
    }

    /// <summary>
    /// Gets the letters. String builder example
    /// </summary>
    public static string getLetters()
    {
      string letters = "";
      StringBuilder sb = new StringBuilder();
      for (int i = 65; i <= 90; i++)
      {
        sb.Append((char)i);
        //letters = letters + (char)i; //memory consuming, creates 26 times internaly new strings
      }

      return sb.ToString();
    }
  }
}
