using System.Collections.Generic;

namespace Collections
{
  /// <summary>
  /// 02c - Collections
  /// - Array: fixni delka
  /// - Generic List: flexibilni silnetypovany
  /// - Dictionary: unique key a value pairs collection
  /// </summary>
  internal class Collections
  {
    static void RunExample()
    {
      int[] phone = new int[] { 0,6,0,9, 1,1,2, 1,1,2 };

      phone[6] = 9;//indexovany pristup
      //phone.Length;

      List<int> phoneList = new List<int>();//generic collection
      phoneList.Add(0609112112);
      //phoneList.Add(12.3); //selze, neni integer
      //phoneList.Count;
      int[] simplePhoneList = phoneList.ToArray();

      Dictionary<int, string> preferedCars = new Dictionary<int, string>();
      preferedCars.Add(1, "Audi");
      if(!preferedCars.ContainsValue("BMW"))
      {
        preferedCars.Add(2, "BMW");
      }

      // jine kolekce:
      // - SortedList, SortedDictionary
      // - Queue
      // - Stack
      // - HashTable

      Zafrajer();
    }

    /// <summary>
    /// Nesmyslny priklad z praxe
    /// </summary>
    private static void Zafrajer()
    {
      string compDataConfigId = "neco";
      List<string> compIDs = new List<string>();
      bool toDel = false;

      foreach (object delID in compIDs)
      {
        if (delID is string &&
          (string)delID == compDataConfigId)
        {
          toDel = true;
          break;
        }
      }

      if(toDel)
      {
        // spachej neco...
      }

    }

    /// <summary>
    /// Spravna varianta metody Zafrajer
    /// </summary>
    private static void ZafrajerSpravne()
    {
      string compDataConfigId = "neco";
      List<string> compIDs = new List<string>();

      if (compIDs.Contains(compDataConfigId))
      {
        // spachej neco...
      }
    }
  }
}
